#include <stdio.h>

#define PRINT(T) \
  void print_##T(T t) { \
    t.print();      \
  }


typedef struct {
  void (*print)();
} Foo;

PRINT(Foo);

void foo_print() {
  printf("foo\n");
}

int main() {
  Foo f;
  f.print = foo_print;

  print_Foo(f);
}
